#!/usr/bin/perl 

# $Id: add-scribe-admin.pl,v 1.4 2004/09/03 11:46:13 joel Exp $
#
#  This code was developped by IDEALX (http://IDEALX.org/) and
#  contributors (their names can be found in the CONTRIBUTORS file).
#
#                 Copyright (C) 2002 IDEALX
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
#  USA.

# Ajout des attributs professeur 
# à un utilisateur créé avec smbldap-useradd
# Scribe 1.0
# Equipe Eole eole@ac-dijon.fr

use strict;
use FindBin;
use FindBin qw($RealBin);
use lib "$RealBin/";
use smbldap_tools;

use Getopt::Std;
my %Options;

my $ok = getopts('p:n:d:m:M:D:a:c:f:b:?', \%Options);

if ( (!$ok) || (@ARGV < 1) || ($Options{'?'}) ) {
	print "Usage: $0 [-pndmMDaf?] username\n";
	print "  -p 	prénom de l'utilisateur\n";
	print "  -n 	nom de l'utilisateur\n";
	print "  -c	code civilité (1, 2 ou 3)\n";
	print "  -b	date de naissance\n";
	print "  -d 	domaine (si @ mail locale)\n";
	print "  -m 	adresse mail (si externe)\n";
	print "  -M	Meflcf (code section)\n";
	print "  -D	Div (code classe)\n";
	print "  -a	droits admin (0 ou 2)\n";
	print "  -f	adresse de redirection des mails (optionnelle)\n";
	print "  -?	show this help message\n";
	exit (1);
}

# arguments de la ligne de commande :
my $nom=$Options{'n'};
if (!defined $nom){
   print "Erreur Option n";
   exit();
}
my $prenom=$Options{'p'};
if (!defined $prenom){
   print "Erreur Option p";
   exit();
}
my $codecivilite=$Options{'c'};
if (!defined $codecivilite){
   print "Erreur Option c";
   exit();
}
my $machin=$Options{'M'};
if (!defined $machin){
   print "Erreur Option M";
   exit();
}
my $divcod=$Options{'D'};
if (!defined $divcod){
   print "Erreur Option D";
   exit();
}
my $admin=$Options{'a'};
if (!defined $admin){
   print "Erreur Option a";
   exit();
}

# uid en dernier argument
my $userName=$ARGV[0];

my $mail=$Options{'m'};
my $domaine=$Options{'d'};
if (!defined $mail) {
   if(!defined $domaine){
      print "Erreur Option d/m";
      exit();
   }
   # adresse en local
   $mail=$userName."\@".$domaine;
}
else {
   # mail et domaine NON cumulables
   $domaine="";
}
my $birthdate=$Options{'b'};
if (!defined $birthdate){
   $birthdate="";
}

# facultatif
my $forward=$Options{'f'};


# ATTENTION : visiblement : obligation de laisser les objectClass préexistants
# directive du 28/10/2003 => plus de boite mail locale pour les profs
# mailHost: localhost
# Maildir: /home/$userName/MailDir

# sous-branche professeurs
my $profsdn="ou=local,ou=personnels,".$config{usersdn};

my @mods;
push(@mods,'objectclass'=>["inetOrgPerson","posixAccount","sambaSAMAccount","administrateur"]);
push(@mods,'typeadmin'=>"$admin");
push(@mods,'cn'=>"$prenom $nom");
push(@mods,'sn'=>"$nom");
push(@mods,'givenName'=>"$prenom");
push(@mods,'displayName'=>"$prenom $nom");
push(@mods,'codecivilite'=>"$codecivilite");
push(@mods,'mail'=>"$mail");
push(@mods,'Meflcf'=>"$machin");
push(@mods,'Divcod'=>"$divcod");

if ($birthdate) {
	push(@mods,'dateNaissance'=>"$birthdate");
}

if ($domaine) {
	my $lettre=substr $userName, 0, 1;
	push(@mods,'mailHost'=>"localhost");
	push(@mods,'Maildir'=>"/home/$lettre/$userName/MailDir/");
}   

my $ldap_master=connect_ldap_master();
my $modify = $ldap_master->modify("uid=$userName,$profsdn",
		'replace' => {@mods}
		);
$modify->code && warn "Failed to add entry: ", $modify->error;
$ldap_master->unbind;
