#!/usr/bin/perl  -w

# $Id: add-scribe-eleve.pl,v 1.4 2004/07/01 15:13:22 joel Exp $
#
#  This code was developped by IDEALX (http://IDEALX.org/) and
#  contributors (their names can be found in the CONTRIBUTORS file).
#
#                 Copyright (C) 2002 IDEALX
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
#  USA.
# MODIFIE en 05/2003 par joel Cuissinat pour Eole
# Purpose of smbldap-useradd : user (posix,shadow,samba) add

# Ajout des attributs élève
# à un utilisateur créé avec smbldap-useradd
# Scribe 1.0
# Equipe Eole eole@ac-dijon.fr

use strict;
use FindBin;
use FindBin qw($RealBin);
use lib "$RealBin/";
use smbldap_tools;

use Getopt::Std;
my %Options;

my $ok = getopts('n:p:d:M:D:c:b:e:R:?', \%Options);

if ( (!$ok) || (@ARGV < 1) || ($Options{'?'}) ) {
	print "Usage: $0 [-npdMDcbeR?] username\n";
       	print "  -p     prénom de l'utilisateur\n";
        print "  -n     nom de l'utilisateur\n";
	print "  -d     domaine pour l'adresse mail\n";
	print "  -M     Meflcf (code section)\n";
	print "  -D     Div (code classe)\n";
	print "  -c	code civilité 1 ,2 ou 3)\n";
	print "  -b	date de naissance\n";
	print "  -e	numéro élève\n";
	print "  -R	RNE de l'établissement\n";
	print "  -?	show this help message\n";
	exit (1);
}

# arguments de la ligne de commande
my $nom=$Options{'n'};
if (!defined $nom){
   print "Erreur Option n";
   exit();
}
my $prenom=$Options{'p'};
if (!defined $prenom){
   print "Erreur Option p";
   exit();
}
my $codecivilite=$Options{'c'};
if (!defined $codecivilite){
   print "Erreur Option c";
   exit();
}
my $birthdate=$Options{'b'};
if (!defined $birthdate){
   print "Erreur Option b";
   exit();
}
my $empnum=$Options{'e'};
if (!defined $empnum){
   print "Erreur Option e";
   exit();
}
my $domaine=$Options{'d'};
if (!defined $domaine){
   print "Erreur Option d";
   exit();
}
my $machin=$Options{'M'};
if (!defined $machin){
   print "Erreur Option M";
   exit();
}
my $divcod=$Options{'D'};
if (!defined $divcod){
   print "Erreur Option D";
   exit();
}
my $rne=$Options{'R'};
if (!defined $rne){
   print "Erreur Option R";
   exit();
}

# uid en dernier argument
my $userName=$ARGV[0];

# adresse e-mail 
my $mail=$userName."\@".$domaine;

# sous-branche élèves
my $elevesdn="ou=local,ou=eleves,".$config{usersdn};

my @mods;
push(@mods,'objectclass'=>["inetOrgPerson","posixAccount","sambaSAMAccount","Eleves"]);
push(@mods,'cn'=>"$prenom $nom");
push(@mods,'sn'=>"$nom");
push(@mods,'givenName'=>"$prenom");
push(@mods,'displayName'=>"$prenom $nom");
push(@mods,'codecivilite'=>"$codecivilite");
push(@mods,'postalAddress'=>"none");
push(@mods,'mail'=>"$mail");
push(@mods,'mailHost'=>"localhost");
push(@mods,'employeeNumber'=>"$empnum");
push(@mods,'rne'=>"$rne");
push(@mods,'dateNaissance'=>"$birthdate");
push(@mods,'Meflcf'=>"$machin");
my $premiere_lettre=substr($userName,0,1);
push(@mods,'Maildir'=>"/home/$premiere_lettre/$userName/MailDir/");
push(@mods,'Divcod'=>"$divcod");

my $ldap_master=connect_ldap_master();
my $modify = $ldap_master->modify("uid=$userName,$elevesdn",
			'replace' => {@mods}
		);
$modify->code && warn "Failed to add entry: ", $modify->error;
$ldap_master->unbind;
