#!/usr/bin/env python
# -*- coding: utf-8 -*-

#################################################
#                                               #
# Script de création de l'utilisateur user.assr #
# Eole <eole@ac-dijon.fr>                       #
#                                               #
#################################################

import sys

from os import system
from commands import getoutput
#from ParseDico import ParseDico
from creole import parsedico
from getopt import getopt, GetoptError


def creation(delete=False):
    """cree l'utilisateur user.assr de type eleve,
    la classe cassr et le niveau nassr
    option = pre-suppression de user.assr s'il existe deja
    """
    # utilisation du dictionnaire EOLE
    dicoEole = parsedico.parse_dico()
    
    # definition des scripts
    dico = dict(s_create_ele = '/usr/share/eole/backend/creation-eleve.py')
    dico['s_create_grp'] = '/usr/share/eole/backend/creation-groupe.py'
    dico['s_mk_passwd'] = '/usr/bin/pwgen -1A'
    dico['s_user_del'] = '/usr/sbin/smbldap-userdel'

    # definition des variables
    samba_server = dicoEole["smb_netbios_name"]
    user = 'user.assr'
    passwd = getoutput('%(s_mk_passwd)s'%dico)
    dico.update(dict(user = user, u = user[0], samba_server = samba_server, passwd = passwd))
    
    # definition des paramètres
    dico['p_create_ele'] = '-u %(user)s -c cassr -n nassr -m %(passwd)s -p user -f assr -x 0 -d 19990101 -o 1 -D restreint -q 0 -P 1'%dico
    dico['p_create_grp1'] = '-g nassr -t Niveau'
    dico['p_create_grp2'] = '-g cassr -t Classe -n nassr'

    # creation des groupes
    system('%(s_create_grp)s %(p_create_grp1)s &> /dev/null'%dico)
    system('%(s_create_grp)s %(p_create_grp2)s &> /dev/null'%dico)
    # creation de l'utilisateur
    if system('id %(user)s &> /dev/null'%dico) == 0:
        if delete:
            system('%(s_user_del)s %(user)s'%dico)
        else:
            print "L'utilisateur %(user)s existe déjà."%dico
            print getoutput('id %(user)s'%dico)
            return

    # creation de l'utilisateur
    system('%(s_create_ele)s %(p_create_ele)s'%dico)
    print 'Le mot de passe de "user.assr" est : %(passwd)s'%dico


def aide():
    print """
Crée l'utilisateur "user.assr" pour l'application Epreuve@SSR
Usage :
%(app)s -c create
%(app)s -c -d --delete (supprime l'utilisateur "user.assr" si existant, et le re-crée)
"""%dict(app = sys.argv[0])

def main():
    """
    """
    try:
        options, args = getopt(sys.argv[1:],'cdh',
        ['create',
        'delete',
        'help'])

    except GetoptError:
        er_type, er_value, er_traceback = sys.exc_info()
        er_msg = str(er_value)
        sys.exit("l'option -%s est inconnue ou nécessite un argument" % er_msg.split(' ')[1])

    # ne pas effacer par defaut
    delete = False
    create = False
    
    for (opt,val) in options:
        # effacer si existant
        if (opt == '-d') or (opt == '--delete'):
            delete = True
        elif (opt == '-c') or (opt == '--create'):
            create = True
        elif (opt == '-h') or (opt == '--help'):
            aide()
            return
    if create: creation(delete)
    else: aide()

if __name__ == '__main__':
    main()
