#!/usr/bin/env python
# -*- coding: UTF-8 -*-

__authors__ = "joel"
__date__ = "octobre 2005"

'''
Ajout/Suppression d'un compte mail
'''

import os
from scribe.backend_conf import *
import getopt 
import sys
from creole import parsedico
dicoEole = parsedico.parse_dico()
branche = 'ou='+dicoEole["numero_etab"]+',ou='+dicoEole["nom_academie"]+',ou=education,o=gouv,c=fr'    

def usage () :
    print """  arguments:
                -u "uid de l'utilisateur"
                -p "mot de passe"
                [-d interne]
                [-m] (modification)
                [-r] (suppression)
                -h aide

  exemple : """+sys.argv[0]+""" -u toto -p monpwd
  """

def traitement(uid, crypt, prefix):
	
    mail = uid+'@'+prefix+dicoEole['domaine_messagerie_etab']
    ldif = """dn: uid=%s,ou=mails,ou=utilisateurs,%s
objectClass: inetOrgPerson
objectClass: administrateur
uid: %s
cn: %s
sn: %s
displayName: %s
givenName: %s
mail: %s
mailHost: localhost
mailDir: /var/spool/mail/%s/
userPassword: %s
typeadmin: 0
codecivilite: 1
"""
    ldif = ldif % (uid,branche,uid,uid,uid,uid,uid,mail,uid,crypt)
    cmd = "echo \""+ldif+"\" | ldapadd -x -D cn=admin,o=gouv,c=fr -w "+ldap_passwd+" > /dev/null 2>&1"
    r = os.system(cmd)
    if r != 0 :
        if r==17408 :
            print "Le compte "+uid+" existe déjà."
        else :
            print "Erreur dans la création de l'utilisateur."
	sys.exit(0)
	
    entete = "Bienvenue sur "+prefix+dicoEole['domaine_messagerie_etab']
    message = "Votre compte de messagerie est actif"
    os.system ("echo \""+message+"\" | mail "+mail+" -s \""+entete+"\"");
    print "Le compte mail "+mail+" a été ajouté."

def modify(uid, crypt):
    ldif = """dn: uid=%s,ou=mails,ou=utilisateurs,%s
changetype: modify
replace: userPassword
userPassword: %s
"""
    ldif = ldif % (uid,branche,crypt)
    cmd = "echo \""+ldif+"\" | ldapadd -x -D cn=admin,o=gouv,c=fr -w "+ldap_passwd+" > /dev/null 2>&1"
    r = os.system(cmd)
    if r != 0 :
        print "Erreur dans la modification de l'utilisateur."
        sys.exit(0)
    print "Le compte mail "+uid+" a été modifié."
    sys.exit(1)
    
def userdel(uid):
    dn = "uid=%s,ou=mails,ou=utilisateurs,%s" % (uid,branche)
    cmd = "ldapdelete -x -D cn=admin,o=gouv,c=fr -w "+ldap_passwd+" "+dn+" > /dev/null 2>&1"
    r = os.system(cmd)
    os.system("rm -rf /var/spool/mail/"+uid)

def _cryptpassword(password):
    output = os.popen("/usr/share/eole/backend/gen_SSHA.pl -p \""+password+"\"")
    crypt = output.readlines()[0]
    output.close()
    return crypt

def main():
    user = None
    password = None
    predomain = ''
    remove=modif=0
    # récupération des arguments de la ligne de commande
    try:
        options, args = getopt.getopt(sys.argv[1:],'u:p:d:rmh', 
	                ['user=','password=','domain=','help'])

    except getopt.GetoptError:
        er_type, er_value, er_traceback = sys.exc_info()
        er_msg = str(er_value)
        sys.exit("l'option -%s est inconnue ou nécessite un argument" % er_msg[er_msg.index('-')+1])

    verification=0
    for (opt,val) in options:
        if (opt == '-u') or (opt == '--user'):
            user = val
        elif (opt == '-p') or (opt == '--password'):
            password = val
        elif (opt == '-d') or (opt == '--domain'):
            if val == 'interne' :
                predomain='i-'
        elif (opt == '-m') :
            modif = 1
        elif (opt == '-r') :
            remove = 1        
        elif (opt == '-h') or (opt == '--help'):
            usage()
            sys.exit(0)
    
    if user == 'administrateur' :
        print 'Ce compte est un compte réservé'
        sys.exit(0)
    
    if user and remove==1 :
        userdel(user)
        sys.exit(0)
    
    if (not user) or (not password) :
        usage()
        sys.exit(0)

    if modif == 1 :
        crypt = _cryptpassword(password)
        modify(user, crypt)

    else:
        # test user SAMBA
        test = os.system("id "+user+" >/dev/null 2>&1")
        if test == 0 :
            print "Le compte "+user+" existe déjà."
            sys.exit(0)
        crypt = _cryptpassword(password)
        traitement(user, crypt, predomain)


if __name__ == '__main__':
    main()
