#!/usr/bin/env python
# -*- coding: UTF-8 -*-

# Mise à jour du mot de passe LDAP 
# Scribe 1.0
# Equipe Eole eole@ac-dijon.fr

import os,sys
# récupération du dictionnaire des fichiers à modifier
from password_files import modifs

# on demande le nouveau mot de passe
# si il n'est pas passé comme paramètre
try:
    new_pass = sys.argv[1]
except:
    new_pass = ""
    while len(new_pass) < 5:
        if new_pass != "":
            print "le mot de passe est trop court (5 caractères au moins)"
        new_pass = raw_input("\nNouveau mot de passe pour l'admin LDAP ? ")
    reconfigure = 1
else:
    reconfigure = 0

# récupération du mot de passe crypté
cmd = "slappasswd -s "+new_pass
entree,sortie=os.popen2(cmd)
res = sortie.read()
crypt_pwd = res.strip()

# parcours du dictionnaire
for file_path in modifs.keys():

    chaines_recherche = modifs[file_path]
    # compatibilité ancienne version
    if type(chaines_recherche) != tuple :
        chaines_recherche=(chaines_recherche,)
	
    for chaine_recherche in chaines_recherche:
	    
        # lecture du fichier de conf
        conf_file = open(file_path,"r")
        print "\nMise à jour du fichier "+file_path+".."
        buffer_in=conf_file.readlines()
        conf_file.close()

        buffer_out = ""
        # on parcourt le fichier
        for line in buffer_in:
            # si la ligne actuelle contient la chaine recherchée
            if line.startswith(chaine_recherche):
                print "définition du mot de passe trouvée : "+line.strip()
                buffer_out += chaine_recherche
                if file_path in ["/etc/ldap/slapd.conf"]:
                    buffer_out += crypt_pwd
                else:
                    buffer_out += new_pass
                if chaine_recherche.endswith('"'):
                    # si le mot de passe est entre guillemets, on ajoute le guillemet fermant
                    buffer_out += '"'
                if file_path.endswith('.pl') or file_path.endswith('.pm') or file_path.endswith('.php'):
                    buffer_out += ';'
                buffer_out += "\n"
            else:
                # sinon, on recopie la ligne d'origine
                buffer_out+=line
            
        # sauvegarde du fichier de conf
        conf_file = open(file_path,"w")
        conf_file.write(buffer_out)
        conf_file.close()

# mise à jour du mot de passe pour egw
if os.path.isdir('/var/lib/mysql/egw'):
    print "\nMise à jour du mot de passe eGroupWare"
    os.system("mysql --user='egw'  --password='eole' -e \"connect egw;update egw_config set config_value='%s' where config_name='ldap_root_pw';\"" % new_pass)

# mise à jour du mot de passe pour samba
print "\nmise à jour de Samba .."
os.system("smbpasswd -w "+new_pass)

if reconfigure == 1:
    print "\nreconfiguration du système, veuillez patienter ..."

# visiblement il vaut mieux le faire à chaque fois surtout pour ldap !    
os.system("/etc/init.d/slapd restart")
os.system("/etc/init.d/samba restart")

