#!/usr/bin/python
# -*- coding: UTF-8 -*-

###############################################################
# utilitaire de suppression d'un partage dans l'annuaire d'Horus
# licence GPL Eole
# conception par Bruno Boiget <bruno.boiget@ac-dijon.fr>
# repris par Joël Cuissinat   <joel.cuissinat@ac-dijon.fr>
###############################################################

#import des modules nécessaires
import sys
import ldap
import manage_special_shares
from os import system
from scribe.backend_conf import *

#####################
# variables globales
#####################

passwd = ldap_passwd

##################
# fonctions LDAP
##################

# supression d'un partage dans l'annuaire
def del_share(share_name):
    """fonction de supression d'un partage dans l'annuaire LDAP
    """
    from special_shares import special_shares
    try:
        query=ldap.open(serveur)
        query.simple_bind_s("cn=admin, o=gouv, c=fr",passwd)
        # on récupère le dn
        result_share=query.search_s("o=gouv, c=fr", ldap.SCOPE_SUBTREE, \
        "(&(objectClass=sambaFileShare)(sambaShareName="+share_name+"))")
        # on supprime l'entrée de l'annuaire
        query.delete(result_share[0][0])
        query.unbind()
    except Exception, e:
        return "Erreur de supression dans LDAP : %s"%e
    else:
        a = manage_special_shares.specialShares()
        a.del_special_share(share_name)
        return "OK"


#####################
# programme principal
#####################

def main():
    try:
        # on affiche le message d'aide si besoin
        if sys.argv[1] in ["--help","-h"]:
            print ("\n syntaxe : "+sys.argv[0]+" partage1,partage2 \n         ou "+sys.argv[0]+" pour le mode interactif \n")
            return
        partages = sys.argv[1].split(',')
    except:
        # demande du partage à supprimer
        partages = []
        partage = ""
        fin_liste = 0
        while fin_liste == 0:
            partage = raw_input("entrez un nom de partage (rien pour terminer la liste) :")
            if partage != "":
                partages.append(partage)
            else:
                fin_liste = 1
                
    # supression des groupes partages
    for partage in partages:
         print del_share(partage)

if __name__ == '__main__':
    main()
